require 'installer/role'
require 'installer/common'

class Installer::Role::Smtp < Installer::Role
  attr_reader :auth, :hostname, :port, :tls, :username, :password

  def initialize(config={})
    super(config)
    @hostname = config[:hostname]
    @port = config[:port] || 25
    @username = config[:username]
    @password = config[:password]
    @tls = config[:tls] || false
    @auth = !@username.nil? && !@password.nil?
  end

  def answers_hash
    hash = super({})
    hash.merge!(
      'q_puppet_enterpriseconsole_smtp_host' => @hostname,
      'q_puppet_enterpriseconsole_smtp_password' => @password,
      'q_puppet_enterpriseconsole_smtp_port' => @port,
      'q_puppet_enterpriseconsole_smtp_use_tls' => true_false_to_yn(@tls),
      'q_puppet_enterpriseconsole_smtp_user_auth' => true_false_to_yn(@auth),
      'q_puppet_enterpriseconsole_smtp_username' => @username,
    )
  end

  def name
    :smtp
  end
end
